#!/usr/bin/env python
#coding: utf-8

import os
import sys
import subprocess
import shutil
import stat
import copy_to_ftp

TAR = "/bin/tar"
MAX_BACKUPS = 7
BACKUP_DIR = "/backup/full"
CURRENT_FILE = "/backup/full/.current"
SOURCE_PATHS = [
    "/command",
    "/data/scripts",
    "/etc",
    "/home",
    "/opt",
    "/packages",
    "/root",
    "/service",
    "/usr/local",
    "/var/spool/cron",
    "/var/qmail",
]


def main():
    # Current-Datei auslesen
    if os.path.isfile(CURRENT_FILE):
        try:
            current = int(file(CURRENT_FILE, "r").readline().strip()) + 1
        except ValueError:
            current = 1
    else:
        current = 1
    if current > MAX_BACKUPS:
        current = 1
    
    # Pfad für Sicherung
    dest_dir = os.path.join(BACKUP_DIR, str(current))
    if os.path.isdir(dest_dir):
        shutil.rmtree(dest_dir, ignore_errors = True)
    os.makedirs(dest_dir)
    os.chmod(BACKUP_DIR, stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR)
    os.chmod(dest_dir, stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR)

    # Ordner sichern
    for path in SOURCE_PATHS:
        print "Backup:", path
        
        # Dateiname zusammensetzen
        file_name = os.path.join(dest_dir, path.replace(os.sep, "_")[1:] + ".tar.gz")

        # Sichern
        args = [TAR, "--create", "--file=%s" % file_name, "--gzip", path]
        proc = subprocess.Popen(args, stdout = subprocess.PIPE, stderr = subprocess.STDOUT)
        for line in proc.stdout:
            if not (
                "Removing leading" in line or
                "socket ignored" in line
            ):
                print "    ", line.rstrip()

    # Current-Datei neu schreiben
    f = file(CURRENT_FILE, "w")
    f.write(str(current))
    f.close()
    
    # Neue Dateien zum FTP-Server kopieren
    if "--copy_to_ftp" in sys.argv:
        copy_to_ftp.copy_to_ftp__full()


if __name__ == "__main__":
    main()

